//native, igy a C rutinoknak sima char*-nak latjak a String instance-kat!
public final class String extends Native
{
	public String(){}
	//public String(String value)		throws NullPointerException;
	//public String(StringBuffer buffer)		throws NullPointerException;
	//public String toString();
	//public boolean equals(Object anObject);
	//public int hashCode();
	//public int length();
	//public char charAt(int index);
	//public void getChars(int srcBegin, int srcEnd, char dst[], int dstBegin)		throws NullPointerException, IndexOutOfBoundsException;
	//public void getBytes(int srcBegin, int srcEnd, byte dst[], int dstBegin)		throws NullPointerException, IndexOutOfBoundsException;
	//public boolean equalsIgnoreCase(String anotherString);
	//public int compareTo(String anotherString)	throws NullPointerException;
	//public boolean regionMatches(int toffset, String other,	int ooffset, int len)	throws NullPointerException;
	//public boolean regionMatches(boolean ignoreCase, int toffset, String other, int ooffset, int len)		throws NullPointerException;
	//public boolean startsWith(String prefix)	throws NullPointerException;
	//public boolean startsWith(String prefix, int toffset)	throws NullPointerException;
	//public boolean endsWith(String suffix)	throws NullPointerException;
	//public int indexOf(int ch);
	//public int indexOf(int ch, int fromIndex);
	//public int indexOf(String str)	throws NullPointerException;
	//public int indexOf(String str, int fromIndex)	throws NullPointerException;
	//public int lastIndexOf(int ch);
	//public int lastIndexOf(int ch, int fromIndex);
	//public int lastIndexOf(String str)	throws NullPointerException;
	//public int lastIndexOf(String str, int fromIndex)	throws NullPointerException;
	//public String substring(int beginIndex);
	//public String substring(int beginIndex, int endIndex);
	//public String concat(String str) throws NullPointerException;
	//public String replace(char oldChar, char newChar);
	//public String toLowerCase();
	//public String toUpperCase();
	//public String trim();
	//public static String valueOf(Object obj);
	//public static String valueOf(char[] data)	throws NullPointerException;
	//public static String valueOf(char[] data, int offset, int count)	throws NullPointerException, IndexOutOfBoundsException;
	//public static String valueOf(int i);
	//public static String valueOf(float f);
	//public String intern();
	
	public native void finalize();

	public String token( int n ){ return token( n, " \t\n" ); }
	public native String token( int n, String delimiters);
	public native int intValue();
	public native float floatValue();
	public native String append( int ascii );
	public native int length();

	final static int TCF_NONE		= 0x00000000;
	final static int TCF_NOSECONDS	= 0x00000001;
	final static int TCF_NOHOURS	= 0x00000002;
	final static int TCF_NOMINUTES	= 0x00000004;
	final static int TCF_SMART		= 0x00000008;
	final static int TCF_VERBOSE	= 0x00000010;
	final static int TCF_US			= 0x00000020;

	public static String timeToString( float sec )
	{
		return timeToString( sec, TCF_NONE );
	}

	public static String timeToString( float sec, int flags  )
	{
		String	time;
		int		hour, min;

		if( sec >= 3600.0 )
		{
			hour = sec / 3600;
			sec -= hour * 3600;
		}

		if( sec >= 60.0 )
		{
			min = sec / 60;
			sec -= min * 60;
		}


		if( !(flags&TCF_NOHOURS) )
		{
			if( flags&TCF_US )
			{
				if( !hour )
					time = "12";
				else
					if( hour > 12 )
						time = (hour-12);
					else
						time = hour;
			}
			else
			{
				if( !hour )
					time = "00";
				else
					if( hour < 10 )
						time = "0" + hour;
					else
						time = hour;
			}

			time = time + ":";
			
		}

		if( !(flags&TCF_NOMINUTES) )
		{
			if( min == 0 && !(flags&TCF_NOHOURS) )
				time = time + "00";
			else
				if( min < 10 && !(flags&TCF_NOHOURS) )
					time = time + "0" + min;
				else
					time = time + min;
		}

		if( !(flags&TCF_NOSECONDS) )
		{
			if( !(flags&TCF_NOMINUTES) )
				time = time + ":";

			if( sec < 10.0 && !(flags&TCF_NOMINUTES) )
				time = time + "0" + sec;
			else
				time = time + sec;
		}

		if( !(flags&TCF_NOHOURS) && flags&TCF_US )
		{
			if( hour >= 12 )
				time = time + "pm";
			else
				time = time + "am";
		}

		return time;
	}


	public static String timeToAlphaString( float fsec, int flags  )
	{
		String	time;
		int		day, hour, min, sec;

		if( fsec >= 86400.0 )
		{
			day = fsec / 86400.0;
			fsec -= day * 86400;

			if( day > 1 )
				time = day + " days ";
			else
				time = day + " day ";
		}

		if( fsec >= 3600.0 )
		{
			hour = fsec / 3600;
			fsec -= hour * 3600;

			if( !(flags&TCF_NOHOURS) )
			{
				if( flags&TCF_VERBOSE )
				{
					if( hour > 1 )
						time = time + hour + " hours ";
					else
						time = time + hour + " hour ";
				}
				else
					time = time + hour + " h ";
			}
		}

		if( fsec >= 60.0 )
		{
			min = fsec / 60;
			fsec -= min * 60;

			if( !(flags&TCF_NOMINUTES) )
			{
				if( flags&TCF_VERBOSE )
				{
					if( min > 1 )
						time = time + min + " minutes ";
					else
						time = time + min + " minute ";
				}
				else
					time = time + min + " min ";
			}
		}

		if( sec = fsec )
		{
			if( !(flags&TCF_NOSECONDS && time ) )
			{
				if( flags&TCF_VERBOSE )
				{
					if( sec > 1 )
						time = time + sec + " seconds";
					else
						time = time + sec + " second";
				}
				else
					time = time + min + " sec";
			}
		}

		return time;
	}

}
